import * as z from 'zod';
import { Prisma } from '../../../generated/prisma';
import Decimal from 'decimal.js';
import { PaymentStatusSchema } from '../enums/PaymentStatus.schema';
import { ServiceLineTransactionUncheckedCreateNestedManyWithoutPaymentInputObjectSchema as ServiceLineTransactionUncheckedCreateNestedManyWithoutPaymentInputObjectSchema } from './ServiceLineTransactionUncheckedCreateNestedManyWithoutPaymentInput.schema';
import { ServiceLineUncheckedCreateNestedManyWithoutPaymentInputObjectSchema as ServiceLineUncheckedCreateNestedManyWithoutPaymentInputObjectSchema } from './ServiceLineUncheckedCreateNestedManyWithoutPaymentInput.schema'

import { DecimalJSLikeSchema, isValidDecimalInput } from '../../helpers/decimal-helpers';
const makeSchema = () => z.object({
  id: z.number().int().optional(),
  claimId: z.number().int().optional().nullable(),
  patientId: z.number().int(),
  userId: z.number().int(),
  updatedById: z.number().int().optional().nullable(),
  npiProviderId: z.number().int().optional().nullable(),
  totalBilled: z.union([
  z.number(),
  z.string(),
  z.instanceof(Decimal),
  z.instanceof(Prisma.Decimal),
  DecimalJSLikeSchema,
]).refine((v) => isValidDecimalInput(v), {
  message: "Field 'totalBilled' must be a Decimal",
}),
  totalPaid: z.union([
  z.number(),
  z.string(),
  z.instanceof(Decimal),
  z.instanceof(Prisma.Decimal),
  DecimalJSLikeSchema,
]).refine((v) => isValidDecimalInput(v), {
  message: "Field 'totalPaid' must be a Decimal",
}).optional(),
  totalAdjusted: z.union([
  z.number(),
  z.string(),
  z.instanceof(Decimal),
  z.instanceof(Prisma.Decimal),
  DecimalJSLikeSchema,
]).refine((v) => isValidDecimalInput(v), {
  message: "Field 'totalAdjusted' must be a Decimal",
}).optional(),
  totalDue: z.union([
  z.number(),
  z.string(),
  z.instanceof(Decimal),
  z.instanceof(Prisma.Decimal),
  DecimalJSLikeSchema,
]).refine((v) => isValidDecimalInput(v), {
  message: "Field 'totalDue' must be a Decimal",
}),
  mhPaidAmount: z.union([
  z.number(),
  z.string(),
  z.instanceof(Decimal),
  z.instanceof(Prisma.Decimal),
  DecimalJSLikeSchema,
]).refine((v) => isValidDecimalInput(v), {
  message: "Field 'mhPaidAmount' must be a Decimal",
}).optional().nullable(),
  copayment: z.union([
  z.number(),
  z.string(),
  z.instanceof(Decimal),
  z.instanceof(Prisma.Decimal),
  DecimalJSLikeSchema,
]).refine((v) => isValidDecimalInput(v), {
  message: "Field 'copayment' must be a Decimal",
}).optional(),
  adjustment: z.union([
  z.number(),
  z.string(),
  z.instanceof(Decimal),
  z.instanceof(Prisma.Decimal),
  DecimalJSLikeSchema,
]).refine((v) => isValidDecimalInput(v), {
  message: "Field 'adjustment' must be a Decimal",
}).optional(),
  status: PaymentStatusSchema.optional(),
  notes: z.string().optional().nullable(),
  icn: z.string().optional().nullable(),
  createdAt: z.coerce.date().optional(),
  updatedAt: z.coerce.date().optional(),
  serviceLineTransactions: z.lazy(() => ServiceLineTransactionUncheckedCreateNestedManyWithoutPaymentInputObjectSchema).optional(),
  serviceLines: z.lazy(() => ServiceLineUncheckedCreateNestedManyWithoutPaymentInputObjectSchema).optional()
}).strict();
export const PaymentUncheckedCreateWithoutCommissionBatchItemsInputObjectSchema: z.ZodType<Prisma.PaymentUncheckedCreateWithoutCommissionBatchItemsInput> = makeSchema() as unknown as z.ZodType<Prisma.PaymentUncheckedCreateWithoutCommissionBatchItemsInput>;
export const PaymentUncheckedCreateWithoutCommissionBatchItemsInputObjectZodSchema = makeSchema();
